//*****************************************************************************
//
//	Grundinitialisierung des ATXmega A1
//
//*****************************************************************************

/* extended fuses 1..0 */

#include <avr/io.h>
//#include <avr/iox128a1.h>
#include "init.h"
#include "NVM.H"
#include <avr/interrupt.h>

//*****************************************************************************
//	Initialisierung nach RESET
//  Input:	-
//	Output:	-
//*****************************************************************************
unsigned char INIT(void)
{
unsigned char uc_Start;

   //Oszillator einstellen
//   OSC.CTRL = OSC_XOSCEN_bm;  /* External Oscillator Enable */
//   while((OSC.STATUS & OSC_XOSCEN_bm) != OSC_XOSCEN_bm); 

//   OSC.CTRL = OSC_RC32KEN_bm; /* Internal 32kHz RC Oscillator Enable */
//   while((OSC.STATUS & OSC_RC32KEN_bm) != OSC_RC32KEN_bm); 

   OSC.CTRL = OSC_RC32MEN_bm; /* Internal 32MHz RC Oscillator Enable */
   while((OSC.STATUS & OSC_RC32MEN_bm) != OSC_RC32MEN_bm); 

//   OSC.CTRL = OSC_RC2MEN_bm;  /* Internal 2MHz RC Oscillator Enable */
//   while((OSC.STATUS & OSC_RC2MEN_bm) != OSC_RC2MEN_bm); 

   
   //CLK PLL
	NVM.CMD = NVM_CMD_READ_CALIB_ROW_gc;  
	OSC.RC32KCAL = PGM_READ_BYTE((unsigned char *) PROD_SIGNATURES_START + RCOSC32K);
//	OSC.RC32MCAL = PGM_READ_BYTE((unsigned char *) PROD_SIGNATURES_START + RCOSC32M);
//	OSC.RC2MCAL = PGM_READ_BYTE((unsigned char *) PROD_SIGNATURES_START + RCOSC2M);
	/* Clean up NVM Command register. */
 	NVM.CMD = NVM_CMD_NO_OPERATION_gc;    //0x00

   
//   OSC.PLLCTRL = OSC_PLLSRC_RC2M_gc;  /* Internal 2MHz RC Oscillator */
   OSC.PLLCTRL = OSC_PLLSRC_RC32M_gc; /* Internal 32MHz RC Oscillator */
//   OSC.PLLCTRL = OSC_PLLSRC_XOSC_gc;  /* External Oscillator */
   
   OSC.PLLCTRL |= 6; //Factor 1..31  max. 200MHz Takt
   
   OSC.CTRL |= OSC_PLLEN_bm;       //PLL an

   OSC.DFLLCTRL = OSC_RC32MCREF_bm; /* 32MHz Calibration Reference */
   DFLLRC32M.CTRL = DFLL_ENABLE_bm;
//or
//   OSC.DFLLCTRL = OSC_RC2MCREF_bm;  /* 2MHz Calibration Reference */
//   DFLLRC2M       = DFLL_ENABLE_bm;
   
   //PLL ok
   while((OSC.STATUS & OSC_PLLRDY_bm) != OSC_PLLRDY_bm); 


   //CLK Source
   CCP = CCP_IOREG_gc; //CPU Change Protection
//   CLK.CTRL = CLK_SCLKSEL_RC2M_gc;  /* Internal 2MHz RC Oscillator */
   CLK.CTRL = CLK_SCLKSEL_RC32M_gc; /* Internal 32MHz RC Oscillator */
//   CLK.CTRL = CLK_SCLKSEL_RC32K_gc; /* Internal 32kHz RC Oscillator */
//   CLK.CTRL = CLK_SCLKSEL_XOSC_gc;  /* External Crystal Oscillator or Clock */
//   CLK.CTRL |= CLK_SCLKSEL_PLL_gc; /* PLL Frequenz */
   
   
   //CLK Precounter 
  CCP = CCP_IOREG_gc; //CPU Change Protection
   CLK.PSCTRL = CLK_PSADIV_1_gc;    /* Divide by 1 */
//   CLK.PSCTRL = CLK_PSADIV_2_gc;    /* Divide by 2 */
//   CLK.PSCTRL = CLK_PSADIV_4_gc;    /* Divide by 4 */
//   CLK.PSCTRL = CLK_PSADIV_8_gc;    /* Divide by 8 */
//   CLK.PSCTRL = CLK_PSADIV_16_gc;   /* Divide by 16 */
//   CLK.PSCTRL = CLK_PSADIV_32_gc;   /* Divide by 32 */
//   CLK.PSCTRL = CLK_PSADIV_64_gc;   /* Divide by 64 */
//   CLK.PSCTRL = CLK_PSADIV_128_gc;  /* Divide by 128 */
//   CLK.PSCTRL = CLK_PSADIV_256_gc;  /* Divide by 256 */
//   CLK.PSCTRL = CLK_PSADIV_512_gc;  /* Divide by 512 */

/* Prescaler B and C Division Factor */
   CCP = CCP_IOREG_gc; //CPU Change Protection
   CLK.PSCTRL = CLK_PSBCDIV_1_1_gc; /* Divide B by 1 and C by 1 */
//   CLK.PSCTRL = CLK_PSBCDIV_1_2_gc; /* Divide B by 1 and C by 2 */
//   CLK.PSCTRL = CLK_PSBCDIV_4_1_gc; /* Divide B by 4 and C by 1 */
//   CLK.PSCTRL = CLK_PSBCDIV_2_2_gc; /* Divide B by 2 and C by 2 */

 
   //No clk changes
//   CLK.LOCK = CLK_LOCK_bm;  /* Clock System Lock */

   //Reset Status
   uc_Start = RST.STATUS;


// Input/Output Ports initialization as input
   // Port A
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   // Port B
   PORTB.DIR = 0xFF;
   PORTB.OUT = 0x00;

   // Port C
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   // Port D
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   // Port E
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   // Port F
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;
 
   // Port H
   PORTH.DIR = 0xFF;
   PORTH.OUT = 0x00;

   // Port J
   PORTJ.DIR = 0xFF;
   PORTJ.OUT = 0x00;

   // Port K 
   PORTK.DIR = 0xFF;
   PORTK.OUT = 0x00;

   // Port Q
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   // Port R  
   PORTA.DIR = 0xFF;
   PORTA.OUT = 0x00;

   
   // Interrupts enable
  sei();  //global INT an
  
  return(uc_Start);
}


