//*****************************************************************************
//
//	Protokoll fuer UART D0
//
//*****************************************************************************
#include "uartD0.h"
#include "protoD0.h"
#include "kommandD0.h"
#include <string.h>
#include <stdlib.h>

#define STARTKENNUNGD0 0x24
#define ENDEKENNUNGD0  0x0d

#ifndef START
#define START        0x01
#define ENDE         0x00
#endif

char c_strRXD0[128];
char c_strTXD0[128];
unsigned char uc_zeichenD0,uc_uartstatusD0 = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART D0
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_UARTD0(void)
{
unsigned char uc_x;

  uc_x = UARTD0_RX();
 
  if (uc_uartstatusD0 == START)
   {
     c_strRXD0[uc_zeichenD0] = uc_x;
	 uc_zeichenD0++;
   }
  
  if (uc_x == STARTKENNUNGD0)
   {
      uc_uartstatusD0 = START;
	  uc_zeichenD0 = 0;
   }	  

  if ((uc_uartstatusD0 == START) && (uc_x == ENDEKENNUNGD0)) 
   {
      uc_uartstatusD0 = ENDE;
	  if (uc_zeichenD0 > 0) uc_zeichenD0--;
	  c_strRXD0[uc_zeichenD0] = '\0';
	  KommandointerpreterD0(c_strRXD0);
   }	    
}


//*****************************************************************************
//	Protokoll - String ueber UART D0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UARTD0(char * pc_str)
{
char c_start[2] = {STARTKENNUNGD0,0x00};
char c_ende[3]  = {ENDEKENNUNGD0,0x00};

  strcpy(c_strTXD0,c_start);
  strcat(c_strTXD0,pc_str);
  strcat(c_strTXD0,c_ende);
  UARTD0_TXStr(c_strTXD0);
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertL(unsigned long ul_x)
{
char c_txt[20];
 
   strcpy(c_txt,"LONG,");
   ltoa(ul_x,c_txt+5,10);
   sende_UARTD0(c_txt);
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertI(unsigned int ui_x)
{
char c_txt[20];

   strcpy(c_txt,"INT,");
   itoa(ui_x,c_txt+4,10);
   sende_UARTD0(c_txt); 
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertH(unsigned int ui_x)
{
char c_txt[20];

   strcpy(c_txt,"INT Hex,");
   itoa(ui_x,c_txt+4,16);
   sende_UARTD0(c_txt);  
}


//*****************************************************************************
//	Protokoll - HexZahl nach int konvertieren
//  Input:	String Hexzahl
//	Output:	Integer Zahl
//*****************************************************************************
unsigned int atoh(char * pc_str)
{
unsigned int ui_x=0,ui_db;
unsigned char uc_len,uc_anz,uc_cnt=0;

  
   uc_len = strlen(pc_str);
   if (uc_len > 0)
   {
     for(uc_anz=uc_len;uc_anz > 0;uc_anz--)
	 { 
	    if (pc_str[uc_anz-1] > 0x39) ui_db = pc_str[uc_anz-1] - 0x37;
		                        else ui_db = pc_str[uc_anz-1] - 0x30;
	    if (ui_db > 0x0F) ui_db = pc_str[uc_anz-1] - 0x57;	
		ui_db = ui_db << uc_cnt;						
		ui_x = ui_x | ui_db;
		uc_cnt = uc_cnt +4;					
	 }
   }
   return(ui_x);
}


