//*****************************************************************************
//
//	Main fuer LCD T6963 Test
//
// *Fuses: 0..5  0x00 0xAA 0xFF 0xF7 0xFF
//
//*****************************************************************************
#include <stdlib.h>
#include <stdbool.h>
#include <inttypes.h>
#include <avr/pgmspace.h>        // put var to program memory
#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <string.h>

#include "init.h"
#include "LCD_T6963.H"
#include "uartD0.h"
#include "PROTOD0.H"
#include "KOMMANDD0.H"


//char pattern[32];

//  				   oben                              unten   
char pattern[32] = { 0x30,0x30,0x30,0x30, 0x30,0x30,0x30,0x3F,	//1
					 0x0C,0x0C,0x0C,0x0C, 0x0C,0x0C,0x0C,0xFC,	//2
					 0x3F,0x30,0x30,0x30, 0x30,0x30,0x30,0x30,	//3
					 0xFC,0x0C,0x0C,0x0C, 0x0C,0x0C,0x0C,0x0C	//4
					};



#define FONT1

//*****************************************************************************
//	main - Main
//  Input:	-
//	Output:	-
//*****************************************************************************
int main(void)
{
unsigned int ui_cnt,ui_x;
char c_txt[5];

	INIT();
	UARTD0_INIT();
	LCD_INIT();

#ifdef FONT1
	LCD_FONT(1);
#else
	LCD_FONT(0);
#endif	

	LCD_INVERS(0);

#ifdef FONT1
//	LCD_WRITESTR(1,1,"ABCDEFGHIJKLMNOPQRSTUVWXYZ01230123456789");
#else
//	LCD_WRITESTR(1,1,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123");
#endif

ui_cnt = 0;
ui_x = 0;
/*
	LCD_CLOCK(LCD_XMAX /2,LCD_YMAX /2,LCD_YMAX -1);

    ui_cnt= 0;
    LCD_SETTIME(14,30,ui_cnt);
*/


//	LCD_GAUGE(LCD_XMAX /2,LCD_YMAX /2,LCD_YMAX -1,120,5,"mV");
//	LCD_GAUGE(LCD_XMAX /2,LCD_YMAX /2,90,120,5,"mV");
//	LCD_GAUGEVALUE(60);

   LCD_CHART(0xCF,"TEST");
   
//   LCD_CHARTYWRITE("ABC","1","2","3","4","5");
   LCD_CHARTXWRITE(0,"ABC");

    while(1)
    {
		if (UARTD0_RXTest()) receive_UARTD0();
/*	
		LCD_DELAY(100);
		ui_cnt++;
        LCD_SETTIME(2,30,ui_cnt);
*/

/*
		LCD_CLEARLINECHARS(1,15,3);
		LCD_WRITELONG(1,15,ui_cnt,10);
		LCD_GAUGEVALUE(ui_cnt);
		ui_cnt++;
		
		if (ui_cnt > 125) ui_cnt = 0;

		LCD_DELAY(100);	
*/

//		LCD_WRITELONG(1,15,ui_cnt,10);
		
	
//		LCD_CHARTVALUE(ui_x,ui_cnt);
		LCD_CHARTSHIFT(ui_cnt,1);
		itoa(ui_cnt,c_txt,10);
		LCD_CHARTXFIRSTWRITE(c_txt);
		
		if ((ui_x & 0x01) == 0)
		 {
			  ui_cnt++; 
		
	 		  if (ui_cnt > 100) 
				{
					ui_cnt = 100;
					ui_x++;
				}
		 }
		 else {
			     if (ui_cnt < 1) 
				  {
					 ui_cnt = 1;
					 ui_x++; 
				  } 
				 ui_cnt--;
			  }

		LCD_DELAY(20);
		
    }
}
